// This file is generated by kconfig_compiler from kmid.kcfg.
// All changes you do to this file will be lost.
#ifndef KMID_SETTINGS_H
#define KMID_SETTINGS_H

#include <kglobal.h>
#include <kconfigskeleton.h>
#include <kdebug.h>

#include <kglobalsettings.h>
#include <kmidmacros.h>
namespace KMid {

class KMIDBACKEND_EXPORT Settings : public KConfigSkeleton
{
  public:
    enum ResetMode { None, GM, GS, XG, Syx };
    enum AudioFluid { fluid_alsa, fluid_pulseaudio, fluid_oss, fluid_jack };
    enum AudioTimidity { timidity_alsa, timidity_pulseaudio, timidity_oss, timidity_jack };

    Settings( );
    ~Settings();

    /**
      Set The font used to display the lyrics.
    */
    void setFont( const QFont & v )
    {
      if (!isImmutable( QString::fromLatin1( "font" ) ))
        mFont = v;
    }

    /**
      Get The font used to display the lyrics.
    */
    QFont font() const
    {
      return mFont;
    }

    /**
      Set Size of the lyrics font
    */
    void setSize( int v )
    {
      if (!isImmutable( QString::fromLatin1( "size" ) ))
        mSize = v;
    }

    /**
      Get Size of the lyrics font
    */
    int size() const
    {
      return mSize;
    }

    /**
      Set Color of the lyrics text, after being played
    */
    void setColor( const QColor & v )
    {
      if (!isImmutable( QString::fromLatin1( "color" ) ))
        mColor = v;
    }

    /**
      Get Color of the lyrics text, after being played
    */
    QColor color() const
    {
      return mColor;
    }

    /**
      Set Initial lyrics text encoding
    */
    void setEncoding( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "encoding" ) ))
        mEncoding = v;
    }

    /**
      Get Initial lyrics text encoding
    */
    QString encoding() const
    {
      return mEncoding;
    }

    /**
      Set MIDI backend.
    */
    void setMidi_backend( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "midi_backend" ) ))
        mMidi_backend = v;
    }

    /**
      Get MIDI backend.
    */
    QString midi_backend() const
    {
      return mMidi_backend;
    }

    /**
      Set MIDI port connection.
    */
    void setOutput_connection( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "output_connection" ) ))
        mOutput_connection = v;
    }

    /**
      Get MIDI port connection.
    */
    QString output_connection() const
    {
      return mOutput_connection;
    }

    /**
      Set MIDI mapper file.
    */
    void setMidi_mapper( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "midi_mapper" ) ))
        mMidi_mapper = v;
    }

    /**
      Get MIDI mapper file.
    */
    QString midi_mapper() const
    {
      return mMidi_mapper;
    }

    /**
      Set Start playing right after loading a song.
    */
    void setPlayer_autostart( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "player_autostart" ) ))
        mPlayer_autostart = v;
    }

    /**
      Get Start playing right after loading a song.
    */
    bool player_autostart() const
    {
      return mPlayer_autostart;
    }

    /**
      Set Loop the play list.
    */
    void setPlayer_loop( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "player_loop" ) ))
        mPlayer_loop = v;
    }

    /**
      Get Loop the play list.
    */
    bool player_loop() const
    {
      return mPlayer_loop;
    }

    /**
      Set Shuffle the play list.
    */
    void setPlaylist_shuffle( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "playlist_shuffle" ) ))
        mPlaylist_shuffle = v;
    }

    /**
      Get Shuffle the play list.
    */
    bool playlist_shuffle() const
    {
      return mPlaylist_shuffle;
    }

    /**
      Set MIDI reset message mode.
    */
    void setReset_mode( ResetMode v )
    {
      if (!isImmutable( QString::fromLatin1( "reset_mode" ) ))
        mReset_mode = v;
    }

    /**
      Get MIDI reset message mode.
    */
    ResetMode reset_mode() const
    {
      return static_cast<ResetMode>(mReset_mode);
    }

    /**
      Set System Exclusive MIDI file for reset message.
    */
    void setSysex_file( const KUrl & v )
    {
      if (!isImmutable( QString::fromLatin1( "sysex_file" ) ))
        mSysex_file = v;
    }

    /**
      Get System Exclusive MIDI file for reset message.
    */
    KUrl sysex_file() const
    {
      return mSysex_file;
    }

    /**
      Set Show advanced MIDI ports.
    */
    void setAdvanced_ports( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "advanced_ports" ) ))
        mAdvanced_ports = v;
    }

    /**
      Get Show advanced MIDI ports.
    */
    bool advanced_ports() const
    {
      return mAdvanced_ports;
    }

    /**
      Set Load and save automatically the song settings.
    */
    void setAuto_song_settings( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "auto_song_settings" ) ))
        mAuto_song_settings = v;
    }

    /**
      Get Load and save automatically the song settings.
    */
    bool auto_song_settings() const
    {
      return mAuto_song_settings;
    }

    /**
      Set Run FluidSynth at startup
    */
    void setExec_fluid( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "exec_fluid" ) ))
        mExec_fluid = v;
    }

    /**
      Get Run FluidSynth at startup
    */
    bool exec_fluid() const
    {
      return mExec_fluid;
    }

    /**
      Set Command
    */
    void setCmd_fluid( const KUrl & v )
    {
      if (!isImmutable( QString::fromLatin1( "cmd_fluid" ) ))
        mCmd_fluid = v;
    }

    /**
      Get Command
    */
    KUrl cmd_fluid() const
    {
      return mCmd_fluid;
    }

    /**
      Set Audio Output
    */
    void setAudio_fluid( AudioFluid v )
    {
      if (!isImmutable( QString::fromLatin1( "audio_fluid" ) ))
        mAudio_fluid = v;
    }

    /**
      Get Audio Output
    */
    AudioFluid audio_fluid() const
    {
      return static_cast<AudioFluid>(mAudio_fluid);
    }

    /**
      Set Audio Device
    */
    void setAudiodev_fluid( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "audiodev_fluid" ) ))
        mAudiodev_fluid = v;
    }

    /**
      Get Audio Device
    */
    QString audiodev_fluid() const
    {
      return mAudiodev_fluid;
    }

    /**
      Set Sample Rate
    */
    void setRate_fluid( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "rate_fluid" ) ))
        mRate_fluid = v;
    }

    /**
      Get Sample Rate
    */
    QString rate_fluid() const
    {
      return mRate_fluid;
    }

    /**
      Set Sound Font
    */
    void setSf2_fluid( const KUrl & v )
    {
      if (!isImmutable( QString::fromLatin1( "sf2_fluid" ) ))
        mSf2_fluid = v;
    }

    /**
      Get Sound Font
    */
    KUrl sf2_fluid() const
    {
      return mSf2_fluid;
    }

    /**
      Set Arguments
    */
    void setArgs_fluid( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "args_fluid" ) ))
        mArgs_fluid = v;
    }

    /**
      Get Arguments
    */
    QString args_fluid() const
    {
      return mArgs_fluid;
    }

    /**
      Set Run TiMidity++ at startup
    */
    void setExec_timidity( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "exec_timidity" ) ))
        mExec_timidity = v;
    }

    /**
      Get Run TiMidity++ at startup
    */
    bool exec_timidity() const
    {
      return mExec_timidity;
    }

    /**
      Set Command
    */
    void setCmd_timidity( const KUrl & v )
    {
      if (!isImmutable( QString::fromLatin1( "cmd_timidity" ) ))
        mCmd_timidity = v;
    }

    /**
      Get Command
    */
    KUrl cmd_timidity() const
    {
      return mCmd_timidity;
    }

    /**
      Set Audio Output
    */
    void setAudio_timidity( AudioTimidity v )
    {
      if (!isImmutable( QString::fromLatin1( "audio_timidity" ) ))
        mAudio_timidity = v;
    }

    /**
      Get Audio Output
    */
    AudioTimidity audio_timidity() const
    {
      return static_cast<AudioTimidity>(mAudio_timidity);
    }

    /**
      Set Audio Device
    */
    void setAudiodev_timidity( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "audiodev_timidity" ) ))
        mAudiodev_timidity = v;
    }

    /**
      Get Audio Device
    */
    QString audiodev_timidity() const
    {
      return mAudiodev_timidity;
    }

    /**
      Set Sample Rate
    */
    void setRate_timidity( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "rate_timidity" ) ))
        mRate_timidity = v;
    }

    /**
      Get Sample Rate
    */
    QString rate_timidity() const
    {
      return mRate_timidity;
    }

    /**
      Set Arguments
    */
    void setArgs_timidity( const QString & v )
    {
      if (!isImmutable( QString::fromLatin1( "args_timidity" ) ))
        mArgs_timidity = v;
    }

    /**
      Get Arguments
    */
    QString args_timidity() const
    {
      return mArgs_timidity;
    }

    /**
      Set Enable DLS Synth at startup
    */
    void setExec_dls( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "exec_dls" ) ))
        mExec_dls = v;
    }

    /**
      Get Enable DLS Synth at startup
    */
    bool exec_dls() const
    {
      return mExec_dls;
    }

    /**
      Set Default Apple DLS Sound Set
    */
    void setDefault_dls( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "default_dls" ) ))
        mDefault_dls = v;
    }

    /**
      Get Default Apple DLS Sound Set
    */
    bool default_dls() const
    {
      return mDefault_dls;
    }

    /**
      Set Sound Font
    */
    void setSoundfont_dls( const KUrl & v )
    {
      if (!isImmutable( QString::fromLatin1( "soundfont_dls" ) ))
        mSoundfont_dls = v;
    }

    /**
      Get Sound Font
    */
    KUrl soundfont_dls() const
    {
      return mSoundfont_dls;
    }

    /**
      Set Use Internal Reverb
    */
    void setReverb_dls( bool v )
    {
      if (!isImmutable( QString::fromLatin1( "reverb_dls" ) ))
        mReverb_dls = v;
    }

    /**
      Get Use Internal Reverb
    */
    bool reverb_dls() const
    {
      return mReverb_dls;
    }

  protected:

    // Settings
    QFont mFont;
    int mSize;
    QColor mColor;
    QString mEncoding;
    QString mMidi_backend;
    QString mOutput_connection;
    QString mMidi_mapper;
    bool mPlayer_autostart;
    bool mPlayer_loop;
    bool mPlaylist_shuffle;
    int mReset_mode;
    KUrl mSysex_file;
    bool mAdvanced_ports;
    bool mAuto_song_settings;
    bool mExec_fluid;
    KUrl mCmd_fluid;
    int mAudio_fluid;
    QString mAudiodev_fluid;
    QString mRate_fluid;
    KUrl mSf2_fluid;
    QString mArgs_fluid;
    bool mExec_timidity;
    KUrl mCmd_timidity;
    int mAudio_timidity;
    QString mAudiodev_timidity;
    QString mRate_timidity;
    QString mArgs_timidity;
    bool mExec_dls;
    bool mDefault_dls;
    KUrl mSoundfont_dls;
    bool mReverb_dls;

  private:
};

}

#endif

